<template>
  <div class="m-4 mr-0 overflow-hidden bg-white" style="width:70%;padding: 10px;">
    <!--引用表格-->
   <BasicTable @register="registerTable" :rowSelection="rowSelection">
     <!--插槽:table标题-->
      <template #tableTitle>
          <a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined"> 新增</a-button>
          
          <a-dropdown v-if="selectedRowKeys.length > 0">
              <template #overlay>
                <a-menu>
                  <a-menu-item key="1" @click="batchHandleDelete">
                    <Icon icon="ant-design:delete-outlined"></Icon>
                    删除
                  </a-menu-item>
                </a-menu>
              </template>
              <a-button>批量操作
                <Icon icon="mdi:chevron-down"></Icon>
              </a-button>
        </a-dropdown>
      </template>
       <!--操作栏-->
      <template #action="{ record }">
        <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)"/>
      </template>
    
    </BasicTable>
    <!-- 表单区域 -->
    <MetricAppSystemReportModal @register="registerModal" @success="handleSuccess"></MetricAppSystemReportModal>
  </div>
</template>

<script lang="ts" name="metric-metricAppSystemReport" setup>
  import {ref, computed, unref} from 'vue';
  import {BasicTable, useTable, TableAction} from '/@/components/Table';
  import {useModal} from '/@/components/Modal';
  import { useListPage } from '/@/hooks/system/useListPage'
  import MetricAppSystemReportModal from './components/MetricAppSystemReportModal.vue'
  import {columns, searchFormSchema} from './MetricAppSystemReport.data';
  import {list, deleteOne, batchDelete} from './MetricAppSystemReport.api';
  import { useMessage } from '/@/hooks/web/useMessage';
  const checkedKeys = ref<Array<string | number>>([]);
  const [registerModal, {openModal}] = useModal();
  const { createMessage } = useMessage();
  const appSystem = ref();

  const { prefixCls,tableContext } = useListPage({
      tableProps:{
           title: '应用系统运行记录表',
           api: list,
           columns,
           size:"small",
           canResize:false,
           useSearchForm:false,
           pagination:true,
           clickToRowSelect:true,
           //inset:true,
           actionColumn: {
               width: 150,
               fixed:'right'
            },
            beforeFetch(params) {
              if(appSystem.value){
                params['appSysId'] = appSystem.value.id
                params = Object.assign(params)  
              }
            },
          
      }
  })

  const [registerTable, {reload},{ rowSelection, selectedRowKeys}] = tableContext

  function handleAdd() {
    if(appSystem.value && appSystem.value.id) {
      openModal(true, {
        appSysId:appSystem.value.id,
        isUpdate: false,
        showFooter: true,
      });
    } else {
      createMessage.info("请选择重要信息系统");
      return false;
    }
  }

  function handleEdit(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: true,
     });
   }

  function handleDetail(record: Recordable) {
     openModal(true, {
       record,
       isUpdate: true,
       showFooter: false,
     });
   }

  async function handleDelete(record) {
     await deleteOne({id: record.id}, handleSuccess);
   }
 
  async function batchHandleDelete() {
     await batchDelete({ids: selectedRowKeys.value}, handleSuccess);
   }

  function handleSuccess() {
      (selectedRowKeys.value = []) && reload();
   }

  function getTableAction(record){
      return [
        {
          label: '编辑',
          onClick: handleEdit.bind(null, record),
        }
      ]
   }

  function getDropDownAction(record){
       return [
         {
           label: '详情',
           onClick: handleDetail.bind(null, record),
         }, {
           label: '删除',
           popConfirm: {
             title: '是否确认删除',
             confirm: handleDelete.bind(null, record),
           }
         }
       ]
   }

   function setData(data) {
     appSystem.value = data
     reload()
   }

   defineExpose({
    setData,
    })

</script>

<style scoped>

</style>